// -------------------------------------------------------------------------------
// 
// 		cwCu		_VF[_[`R[h
// 
// 				Ver 3.12c
// 
// -------------------------------------------------------------------------------

// ʕ

#include "../Main/DxVertexShader.h"

// _VF[_[̓
struct VS_INPUT
{
	float4 Position        : POSITION ;			// W( [J )
	float3 Normal          : NORMAL0 ;			// @( [J )
	float4 Diffuse         : COLOR0 ;			// fBt[YJ[
	float4 Specular        : COLOR1 ;			// XyLJ[
	float4 TexCoords0      : TEXCOORD0 ;		// eNX`W
	float4 TexCoords1      : TEXCOORD1 ;		// TueNX`W

#ifdef BUMPMAP
	// ov}bv
	float3 Tan             : TANGENT0 ;			// ڐ( [J )
	float3 Bin             : BINORMAL0 ;		// ]@( [J )
#endif // BUMPMAP

#ifdef SKINMESH
	// XLjObV
	int4   BlendIndices0   : BLENDINDICES0 ;	// {[p Float^萔zCfbNXO
	float4 BlendWeight0    : BLENDWEIGHT0 ;		// {[pEGCglO

	#ifdef BONE8

		int4   BlendIndices1   : BLENDINDICES1 ;	// {[p Float^萔zCfbNXP
		float4 BlendWeight1    : BLENDWEIGHT1 ;		// {[pEGCglP

	#endif // BONE8

#endif // SKINMESH
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 Position        : POSITION ;		// W( vWFNV )
	float4 Diffuse         : COLOR0 ;		// fBt[YJ[
#if USE_SPE
	float4 Specular        : COLOR1 ;		// XyLJ[
#endif
	float4 TexCoords0_1    : TEXCOORD0 ;	// eNX`WƃTueNX`W( x:eNX`Wx  y:eNX`Wy  z:TueNX`Wx  w:TueNX`Wy )
#if ( ( BUMPMAP || PHONG ) && USE_SPE ) || SHADOWMAP
	float4 V_to_Eye_ShadowMap3PosZ : TEXCOORD1 ;	// _W王ւ̃xNg( r[ )ƃVhE}bvR̃CgZW( w )
#endif
#if ( BUMPMAP == 0 && PHONG ) || SM_3
	float4 Normal_Fog      : TEXCOORD2 ;	// x.y.z:@( r[ )  w:SM3.0p̃tHOp[^
#endif
#if LG0_USE && ( BUMPMAP || PHONG )
	float4 Light0_Dir_Gen  : TEXCOORD3 ;	// xyz:CgŐtxNg( r[ ) w:CgO
#endif
#if LG1_USE && ( BUMPMAP || PHONG )
	float4 Light1_Dir_Gen  : TEXCOORD4 ;	// xyz:CgP̋txNg( r[ ) w:CgP
#endif
#if LG2_USE && ( BUMPMAP || PHONG )
	float4 Light2_Dir_Gen  : TEXCOORD5 ;	// xyz:CgQ̋txNg( r[ ) w:CgQ
#endif

#if SHADOWMAP || SHADOWMAP_DRAW
	float4 ShadowMap1Pos_ShadowMap3PosX   : TEXCOORD6 ;	// VhE}bvP̃CgW( x, y, z )ƃVhE}bvR̃CgXW( w )
#endif
#if SHADOWMAP
	float4 ShadowMap2Pos_ShadowMap3PosY   : TEXCOORD7 ;	// VhE}bvQ̃CgW( x, y, z )ƃVhE}bvR̃CgYW( w )
#endif

#if SM_3 == 0 && ( FOG_LINEAR || FOG_EXP || FOG_EXP2 )
	float  Fog             : FOG ;			// tHO
#endif
} ;

// _VF[_[̃}eAp[^
struct VS_CONST_MATERIAL
{
	float4 Diffuse ;				// fBt[YJ[
	float4 Specular ;				// XyLJ[
	float4 Power ;					// XyL̋
} ;

// _VF[_[̃Cgp[^
struct VS_CONST_LIGHT
{
	float4 Position ;				// W( r[ )
	float3 Direction ;				// ( r[ )
	float4 Diffuse ;				// fBt[YJ[
	float4 Specular ;				// XyLJ[
	float4 Ambient ;				// ArGgJ[
	float4 Range_FallOff_AT0_AT1 ;	// x:L  y:X|bgCgpFllOff  z:ɂ錸pp[^O  w:ɂ錸pp[^P
	float4 AT2_SpotP0_SpotP1 ;		// x:ɂ錸pp[^Q  y:X|bgCgpp[^O( cos( Phi / 2.0f ) )  z:X|bgCgpp[^P( 1.0f / ( cos( Theta / 2.0f ) - cos( Phi / 2.0f ) ) )
} ;

// _VF[_[̃Cgpp[^
struct VS_CONST_LIGHT_BOOL
{
	bool Use ;						// gpĂ邩ǂ
	bool Point_Or_Spot ;			// |CgCgႵ̓X|bgCg
	bool Spot ;						// X|bgCg
} ;



// C++ Őݒ肷萔̒`
float4              cfZeroOne                                                  : register( c0  /* DX_VS_CONSTF_ZERO_ONE                        */ ) ;	// OƂP̒萔( x:0.0f  y:1.0f )
float4              cfAmbient_Emissive                                         : register( c1  /* DX_VS_CONSTF_AMBIENT_EMISSIVE                */ ) ;	// G~bVuJ[{ArGgJ[( G~bVuJ[ + }eAArGgJ[ * O[oArGgJ[ )
float4              cfProjectionMatrix[ 4 ]                                    : register( c2  /* DX_VS_CONSTF_PROJECTION_MAT                  */ ) ;	// r[@@vWFNVs
float4              cfViewMatrix[ 3 ]                                          : register( c6  /* DX_VS_CONSTF_VIEW_MAT                        */ ) ;	// [h@@r[s
float4              cfFog                                                      : register( c10 /* DX_VS_CONSTF_FOG                             */ ) ;	// tHOpp[^( x:end/(end - start)  y:-1/(end - start)  z:density  w:Rΐ̒ )

VS_CONST_MATERIAL   cfMaterial                                                 : register( c11 /* DX_VS_CONSTF_MATERIAL_START                  */ ) ;	// }eAp[^
VS_CONST_LIGHT      cfLight[ DX_VS_CONSTF_LIGHT_NUM ]                          : register( c14 /* DX_VS_CONSTF_LIGHT_START                     */ ) ;	// Cgp[^
float4              cfToonOutLineSize                                          : register( c42 /* DX_VS_CONSTF_TOON_OUTLINE_SIZE               */ ) ;	// gD[̗֊s̑傫
float4              cfDifSpeSource                                             : register( c43 /* DX_VS_CONSTF_DIF_SPE_SOURCE                  */ ) ;	// x:fBt[YJ[( 0.0f:}eA  1.0f:_ )  y:XyLJ[( 0.0f:}eA  1.0f:_ )

float4              cfShadowMap1LightViewProjectionMatrix[ 4 ]                 : register( c44 /* DX_VS_CONSTF_SHADOWMAP1_LIGHT_VIEW_PROJECTION_MAT */ ) ;	// VhE}bvPp̃Cgr[sƃCgˉesZ
float4              cfShadowMap2LightViewProjectionMatrix[ 4 ]                 : register( c48 /* DX_VS_CONSTF_SHADOWMAP2_LIGHT_VIEW_PROJECTION_MAT */ ) ;	// VhE}bvQp̃Cgr[sƃCgˉesZ
float4              cfShadowMap3LightViewProjectionMatrix[ 4 ]                 : register( c52 /* DX_VS_CONSTF_SHADOWMAP3_LIGHT_VIEW_PROJECTION_MAT */ ) ;	// VhE}bvRp̃Cgr[sƃCgˉesZ

float4              cfTextureMatrix[ DX_VS_CONSTF_TEXTURE_MATRIX_NUM ][ 2 ]    : register( c88 /* DX_VS_CONSTF_TEXTURE_MATRIX_START            */ ) ;	// eNX`Wps
float4              cfLocalWorldMatrix[ DX_VS_CONSTF_WORLD_MAT_NUM * 3 ]       : register( c94 /* DX_VS_CONSTF_WORLD_MAT_START                 */ ) ;	// [J@@[hs

bool                cbFogLinear                                                : register( b0  /* DX_VS_CONSTB_FOG_LINEAR                      */ ) ;	// `tHO|邩ǂ
bool                cbFogExp                                                   : register( b1  /* DX_VS_CONSTB_FOG_EXP                         */ ) ;	// w֐tHO|邩ǂ
bool                cbFogExp2                                                  : register( b2  /* DX_VS_CONSTB_FOG_EXP2                        */ ) ;	// w֐tHOQ|邩ǂ
bool                cbFogUse                                                   : register( b3  /* DX_VS_CONSTB_FOG_USE                         */ ) ;	// tHO|邩ǂ
VS_CONST_LIGHT_BOOL cbLightBool[ DX_VS_CONSTB_LIGHT_NUM ]                      : register( b4  /* DX_VS_CONSTB_LIGHT_START                     */ ) ;	// Cgpp[^



#define ZERO	                cfZeroOne.x
#define ONE                     cfZeroOne.y

#define FOG_LINEAR_ADD          cfFog.x
#define FOG_LINEAR_DIV          cfFog.y
#define FOG_EXP_DENSITY         cfFog.z
#define FOG_EXP_E               cfFog.w

#ifdef SKINMESH
#define LOCAL_WORLD_MAT         lLocalWorldMatrix
#else
#define LOCAL_WORLD_MAT         cfLocalWorldMatrix
#endif
/*
#ifdef DIF_MAT
#define DIF                     cfMaterial.Diffuse
#endif

#ifdef DIF_VTX
#define DIF                     VSInput.Diffuse
#endif

#ifdef SPE_MAT
#define SPE                     cfMaterial.Specular
#endif

#ifdef SPE_VTX
#define SPE                     VSInput.Specular
#endif
*/
#define TEXMTX0_U               cfTextureMatrix[ 0 ][ 0 ]
#define TEXMTX0_V               cfTextureMatrix[ 0 ][ 1 ]

#if SM_3
#define FOG_OUT                 VSOutput.Normal_Fog.w
#else
#define FOG_OUT                 VSOutput.Fog
#endif



